<?php
// $Id: pnuser.php,v 1.8 2002/02/10 21:09:52 jgm Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Jim McDonald
// Purpose of file:  Template user display functions
// ----------------------------------------------------------------------

/**
 * the main user function
 */
function template_user_main()
{
    // Create output object
    $output = new pnHTML();

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(template_usermenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Security check
    if (!pnSecAuthAction(0, 'Template::', '::', ACCESS_READ)) {
        $output->Text(_TEMPLATENOAUTH);
        return $output->GetOutput();
    }

    // Return output
    return $output->GetOutput();
}

/**
 * view items
 */
function template_user_view()
{
    // Create output object
    $output = new pnHTML();

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(template_usermenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Security check
    if (!pnSecAuthAction(0, 'Templates::', '::', ACCESS_READ)) {
        $output->Text(_TEMPLATENOAUTH);
        return $output->GetOutput();
    }

    // Load API
    if (!pnModAPILoad('Template', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    // Get items
    $items = pnModAPIFunc('Template', 'user', 'getall');

    if ($items == false) {
        $output->Text(_TEMPLATEITEMFAILED);
    }

    // Print items
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    foreach ($items as $item) {
        
        if (pnSecAuthAction(0, 'Templates::', "$item[name]::$item[tid]", ACCESS_READ)) {
            $output->URL(pnModURL('Template',
                                  'user',
                                  'display',
                                  array('tid' => $item['tid'])),
                         pnVarPrepForDisplay(pnVarCensor($item['name'])));
            $output->Linebreak();
        }
    }
    $output->SetInputMode(_PNH_PARSEINPUT);

    return $output->GetOutput();
}

/**
 * display item
 */
function template_user_display($args)
{
    // Get parameters from user
    list($tid) = pnVarCleanFromInput('tid');

    // Override if needed from argument array
    extract($args);

    // Create output object
    $output = new pnHTML();

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(template_usermenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Load API
    if (!pnModAPILoad('Template', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    // Get item
    $item = pnModAPIFunc('Template',
                          'user',
                          'get',
                          array('tid' => $tid));

    if ($item == false) {
        $output->Text(_TEMPLATEITEMFAILED);
    }

    // Display item
    $output->Text(_TEMPLATENAME . ': ');
    if (pnModGetVar('Template', 'bold')) {
        $output->BoldText(pnVarCensor($item['name']));
    } else {
        $output->Text(pnVarCensor($item['name']));
    }
    $output->Linebreak(2);
    $output->Text(_TEMPLATENUMBER . ': ');
    $output->Text($item['number']);
    $output->Linebreak(2);


    // Add hooks
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(pnModCallHooks('item',
                                 'display',
                                 $tid,
                                 pnModURL('Template',
                                          'user',
                                          'display',
                                          array('tid' => $tid))));
    $output->SetInputMode(_PNH_PARSEINPUT);

    return $output->GetOutput();
}

/**
 * generate menu fragment
 */
function template_usermenu()
{
    // Create output object
    $output = new pnHTML();

    // Menu table
    $output->TableStart(_TEMPLATE);
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $columns = array();
    $columns[] = $output->URL(pnModURL('Template',
                                       'user',
                                       'view',
                                       array('permtype' => 'group')),
				       _TEMPLATEVIEW);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($columns);
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->TableEnd();

    // Return output
    return $output->GetOutput();
}

?>