<?php
// $Id: pnuserapi.php,v 1.3 2002/02/05 20:30:40 jgm Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Jim McDonald
// Purpose of file:  Template user API
// ----------------------------------------------------------------------

/**
 * get all example items
 * @returns array
 * @return array of items, or false on failure
 */
function template_userapi_getall($args)
{
    $items = array();

    // Security check
    if (!pnSecAuthAction(0, 'Template::', '::', ACCESS_READ)) {
        return $items;
    }

    // Database information
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $templatetable = $pntable['template'];
    $templatecolumn = &$pntable['template_column'];

    // Get items
    $sql = "SELECT $templatecolumn[tid],
                   $templatecolumn[name],
                   $templatecolumn[number]
            FROM $templatetable
            ORDER BY $templatecolumn[name]";
    $result = $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        return false;
    }

    // Put items into result array
    for (; !$result->EOF; $result->MoveNext()) {
        list($tid, $name, $number) = $result->fields;
        if (pnSecAuthAction(0, 'Template::', "$name::$tid", ACCESS_READ)) {
            $items[] = array('tid' => $tid,
                             'name' => $name,
                             'number' => $number);
        }
    }
    $result->Close();

    return $items;
}

/**
 * get a specific item
 * @param $args['tid'] id of example item to get
 * @returns array
 * @return item array, or false on failure
 */
function template_userapi_get($args)
{
    // Get arguments from argument array
    extract($args);

    // Argument check
    if (!isset($tid)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }

    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $templatetable = $pntable['template'];
    $templatecolumn = &$pntable['template_column'];

    // Get item
    $sql = "SELECT $templatecolumn[name],
                   $templatecolumn[number]
            FROM $templatetable
            WHERE $templatecolumn[tid] = " . pnVarPrepForStore($tid);
    $result = $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        return false;
    }

    if ($result->EOF) {
        return false;
    }

    list($name, $number) = $result->fields;

    // Security check
    if (!pnSecAuthAction(0, 'Template::', "$name::$tid", ACCESS_READ)) {
        return false;
    }

    $item = array('tid' => $tid,
                  'name' => $name,
                  'number' => $number);

    return $item;
}

?>